/* 
 * Copyright 2014 SATO taichi
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package example;

import static java.util.concurrent.TimeUnit.*;
import rx.*;

public class ComposeObservable {
	public static void main(String... args) {
		java.util.List<String> list = java.util.Arrays.asList("a", "b", "c");
		Observable<String> data = Observable.from(list);
		Observable<Long> timer = Observable.interval(3, SECONDS);
		timer.zip(data, (seq, str) -> {
			return String.format("[%d %s] ", seq, str);
		}).toBlockingObservable().forEach(System.out::print);
	}
}
