/* 
 * Copyright 2014 SATO taichi
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package example;

public class Fibonacci {
	public static void main(String[] args) {
		rx.Observable.<Long> create(Fibonacci::make)
			.take(10)
			.toBlockingObservable()
			.forEach(System.out::println);
	}

	static void make(rx.Subscriber<? super Long> sub) {
		Long val = 1L, prev = 0L;
		while (sub.isUnsubscribed() == false) {
			long cur = val + prev;
			if (0 < cur) {
				sub.onNext(cur);
			} else {
				sub.onCompleted();
			}
			prev = val;
			val = cur;
		}
	}
}
